---
title: Gamepad.buttons
slug: Web/API/Gamepad/buttons
tags:
  - API
  - Gamepad API
  - Games
  - NeedsBetterSpecLink
  - NeedsMarkupWork
  - Property
  - Reference
  - Référence(2)
---
<p>{{APIRef("Gamepad API")}}</p>

<p>The <code><strong>Gamepad.buttons</strong></code> property of the {{domxref("Gamepad") }} interface returns an array of {{domxref("gamepadButton")}} objects representing the buttons present on the device.</p>

<p>Each entry in the array is 0 if the button is not pressed, and non-zero (typically 1.0) if the button is pressed. Each {{domxref("gamepadButton")}} object has two properties: <code>pressed</code> and <code>value</code>:</p>

<ul>
	<li>The <code>pressed</code> property is a boolean indicating whether the button is currently pressed (<code>true</code>) or unpressed (<code>false</code>).</li>
	<li>The <code>value</code> property is a floating point value used to enable representing analog buttons, such as the triggers on many modern gamepads. The values are normalized to the range 0.0 – 1.0, with 0.0 representing a button that is not pressed, and 1.0 representing a button that is fully pressed.</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">readonly    attribute GamepadButton[]     buttons;</pre>

<h2 id="Example">Example</h2>

<p>The following code is taken from my Gamepad API button demo (you can <a href="https://chrisdavidmills.github.io/gamepad-buttons/">view the demo live</a>, and <a href="https://github.com/chrisdavidmills/gamepad-buttons/tree/master">find the source code</a> on Github.) Note the code fork — in Chrome {{domxref("Navigator.getGamepads")}} needs a <code>webkit</code> prefix and the button values are stores as an array of double values, whereas in Firefox {{domxref("Navigator.getGamepads")}} doesn't need a prefix, and the button values are stored as an array of {{domxref("GamepadButton")}} objects; it is the {{domxref("GamepadButton.value")}} or {{domxref("GamepadButton.pressed")}} properties of these we need to access, depending on what type of buttons they are. In this simple example I've just allowed either.</p>

<pre class="brush: js">function gameLoop() {
  if(navigator.webkitGetGamepads) {
    var gp = navigator.webkitGetGamepads()[0];

    if(gp.buttons[0] == 1) {
      b--;
    } else if(gp.buttons[1] == 1) {
      a++;
    } else if(gp.buttons[2] == 1) {
      b++;
    } else if(gp.buttons[3] == 1) {
      a--;
    }
  } else {
    var gp = navigator.getGamepads()[0];

    if(gp.buttons[0].value &gt; 0 || gp.buttons[0].pressed == true) {
      b--;
    } else if(gp.buttons[1].value &gt; 0 || gp.buttons[1].pressed == true) {
      a++;
    } else if(gp.buttons[2].value &gt; 0 || gp.buttons[2].pressed == true) {
      b++;
    } else if(gp.buttons[3].value &gt; 0 || gp.buttons[3].pressed == true) {
      a--;
    }
  }

  ball.style.left = a*2 + "px";
  ball.style.top = b*2 + "px";

  var start = rAF(gameLoop);
};</pre>

<h2 id="Value">Value</h2>

<p>An array of {{domxref("gamepadButton")}} objects.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName("Gamepad", "#dom-gamepad-buttons", "Gamepad.buttons")}}</td>
			<td>{{Spec2("Gamepad")}}</td>
			<td>Initial definition</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Gamepad.buttons")}}</p>

<div id="compat-mobile"> </div>

<h2 id="See_also">See also</h2>

<p><a href="/en-US/docs/Web/Guide/API/Gamepad">Using the Gamepad API</a></p>
